/**
  PasswordMaker - Creates and manages passwords
  Copyright (C) 2005 Eric H. Jung and LeahScape, Inc.
  http://passwordmaker.org/
  grimholtz@yahoo.com

  This library is free software; you can redistribute it and/or modify it
  under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or (at
  your option) any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  FITNESSFOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
  for more details.

  You should have received a copy of the GNU Lesser General Public License
  along with this library; if not, write to the Free Software Foundation,
  Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 
**/
var passwordMaker = {
  appcontent : null,
  domains : null,
  
  autoPopURLs : null,
  autoPopDefault : false,
  allURLs : null,
    
  passwordMakerHelper : null,
  advancedOptionsDialog : "false", // which dialog to open -- advanced options or basic
  passwordShortcut : "pop-all", // off, pop-all, empty-only, clear-all
  whereLeetLBPredicateRes : null,
  leetLevelLBPredicateRes : null,
  hashAlgorithmLBPredicateRes : null,
  passwordLengthPredicateRes : null,
  urlToUsePredicateRes : null, //http://passwordmaker.mozdev.org/rdf#urlToUse
  urlToMatchPredicateRes : null, //http://passwordmaker.mozdev.org/rdf#urlToMatch
  usernameTBPredicateRes : null,
  counterPredicateRes : null,
  namePredicateRes : null,
  descriptionPredicateRes : null,
  protocolCBPredicateRes : null,
  subdomainCBPredicateRes : null,
  domainCBPredicateRes : null,
  pathCBPredicateRes : null, 
  defaultSubjectRes : null, //http://passwordmaker.mozdev.org/defaults
  //global settings
  globalSettingsSubjectRes : null, //http://passwordmaker.mozdev.org/globalSettings
  masterPasswordPredicateRes : null, //http://passwordmaker.mozdev.org/rdf#masterPassword
  masterPasswordKeyPredicateRes : null,
  masterPasswordStoragePredicateRes : null,
  maskMasterPasswordPredicateRes : null,
  autoClearClipboardPredicateRes : null,
  autoClearClipboardSecondsPredicateRes : null,
  autoPopulatePredicateRes : null,
  advancedOptionsDialogPredicateRes : null,
  charsetPredicateRes : null,
  prefixPredicateRes : null,
  suffixPredicateRes : null,
  passwordShortcutPredicateRes : null,
  //settingsFilePathPredicateRes : null,
  hideMasterPasswordFieldPredicateRes : null,
  formNamePredRes : null,
  fieldNamePredRes : null,
  fieldValuePredRes : null,
  accountsSubjectRes : null,
  domainsSubjectRes : null,
  domainsDatasource : null,

  init : function() {
    this.appcontent = document.getElementById("appcontent");   // Browser
    var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
    this.whereLeetLBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#whereLeetLB");
    this.leetLevelLBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#leetLevelLB");
    this.hashAlgorithmLBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#hashAlgorithmLB");
    this.passwordLengthPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#passwordLength");
    this.urlToUsePredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#urlToUse");
    this.urlToMatchPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#urlToMatch");
    this.usernameTBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#usernameTB");
    this.counterPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#counter");
    this.namePredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#name");
    this.descriptionPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#description");
    this.protocolCBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#protocolCB");
    this.subdomainCBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#subdomainCB");
    this.domainCBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#domainCB");
    this.pathCBPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#pathCB");
    this.charsetPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#charset");
    this.prefixPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#prefix");
    this.suffixPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#suffix");
    this.autoPopulatePredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#autoPopulate");

    this.formNamePredRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#formname");
    this.fieldNamePredRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#fieldname");
    this.fieldValuePredRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#fieldvalue");

    this.defaultSubjectRes = rdfService.GetResource("http://passwordmaker.mozdev.org/defaults");
    this.accountsSubjectRes = rdfService.GetResource("http://passwordmaker.mozdev.org/accounts");
    this.domainsSubjectRes = rdfService.GetResource("http://passwordmaker.mozdev.org/domains");
    
    //global settings
    this.globalSettingsSubjectRes = rdfService.GetResource("http://passwordmaker.mozdev.org/globalSettings");
    this.masterPasswordPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#masterPassword");
    this.masterPasswordKeyPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#masterPasswordKey");
    this.masterPasswordStoragePredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#masterPasswordStorage");
    this.maskMasterPasswordPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#maskMasterPassword");
    this.autoClearClipboardPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#autoClearClipboard");
    this.autoClearClipboardSecondsPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#autoClearClipboardSeconds");
    this.advancedOptionsDialogPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#advancedOptionsDialog");
    this.passwordShortcutPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#passwordShortcut");
    //this.settingsFilePathPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#settingsFilePath");
    this.hideMasterPasswordFieldPredicateRes = rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#hideMasterPasswordField");
    this.passwordMakerHelper = new PasswordMakerHelper();

    // Get MPW if it's been saved to disk
    var oMasterPassword = new MasterPassword(this._getLiteral(this.globalSettingsSubjectRes, this.masterPasswordPredicateRes), // Might be null if user doesn't like to save the master pw
                                             this._getLiteral(this.globalSettingsSubjectRes, this.masterPasswordKeyPredicateRes));

    this.passwordMakerHelper.setEncryptedMasterPassword(oMasterPassword);

    // Which dialog is the preferred one (basic or advanced)?
    this.advancedOptionsDialog = this._getLiteral(this.globalSettingsSubjectRes, this.advancedOptionsDialogPredicateRes);

    // Password Shortcut (ALT-`)
    this.passwordShortcut = passwordMaker._getLiteral(passwordMaker.globalSettingsSubjectRes, passwordMaker.passwordShortcutPredicateRes);;

    this.loadDomains();
    this.loadURLs();

    // Start listening for pageLoads
    this.appcontent.addEventListener("load", this.pageLoad, true);
    // stop listening
    //this.appcontent.removeEventListener("load", this.pageLoad, true);

    // listen for context-menu
    document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", this.contextPopupShowing, false);
  },

  /**
   * Load the list of top-level domains which require second-level
   * domains (e.g., uk) or third, fourth, fifth-level (etc...) domains
   * into this.domains associative array.
   */
  loadDomains : function() {
    var domainIdPredicateRes = this.passwordMakerHelper.rdfService.GetResource("http://passwordmaker.mozdev.org/rdf#domainid");
    this.domains = new Array();
    var compositeDS = Components.classes["@mozilla.org/rdf/datasource;1?name=composite-datasource"].getService(Components.interfaces.nsIRDFCompositeDataSource);
    compositeDS.AddDataSource(this.passwordMakerHelper.datasource);
    compositeDS.AddDataSource(this.passwordMakerHelper.rdfService.GetDataSourceBlocking("chrome://passwdmaker/content/domains.rdf"));

    var domainsContainer = this.passwordMakerHelper.rdfContainerUtils.MakeSeq(compositeDS, this.domainsSubjectRes);
    var domains = domainsContainer.GetElements();
    while (domains.hasMoreElements()) {
      var country = domains.getNext();
      if (country instanceof Components.interfaces.nsIRDFResource) {
        var countryContainer = this.passwordMakerHelper.rdfContainerUtils.MakeSeq(compositeDS, country)
        var subdomains = countryContainer.GetElements();
        while (subdomains.hasMoreElements()) {
          var subdomain = subdomains.getNext();
          var t = subdomain;
          if (subdomain instanceof Components.interfaces.nsIRDFResource) {
            if (!this.passwordMakerHelper.rdfContainerUtils.IsContainer(compositeDS, subdomain)) {
              // Get the domainid target
              var target = this._getLiteral(t, domainIdPredicateRes); // for passwordmaker.rdf (custom domains)
              if (target == null)
                target = subdomain.Value.substring(subdomain.Value.lastIndexOf("/")+1); // for domains.rdf (default domains)
              this.domains[target] = true;     
            }
          }
        }
      }
    }
  },

  loadURLs : function() {
    // Load all URLs (used during alt-` and context-menu select)  
    passwordMaker.allURLs = new Array();
    var resEnum = passwordMaker.passwordMakerHelper.datasource.GetAllResources();
    while (resEnum.hasMoreElements()) {
      var subjectRes = resEnum.getNext(); // e.g., http://passwordmaker.mozdev.org/yahoo/tom_cruise
      var urlToMatch = passwordMaker._getLiteral(subjectRes, passwordMaker.urlToMatchPredicateRes);
      if (urlToMatch != null && urlToMatch != "")
        passwordMaker.allURLs[passwordMaker.allURLs.length] = new Field(subjectRes, urlToMatch); 
    }    
    passwordMaker._loadAutoPopulateURLs();
  },
  
  _loadAutoPopulateURLs : function() {
    // Load auto-pop URLs set to true (used only during pageloads)  
    passwordMaker.autoPopURLs = new Array();
    passwordMaker.autoPopDefault = false;
    var subjectsRes = passwordMaker.passwordMakerHelper.datasource.GetSources(passwordMaker.autoPopulatePredicateRes,
      passwordMaker.passwordMakerHelper.rdfService.GetLiteral("true"), true);
      
    // Now we have all subjects where autoPopulate=true. Get their urlToMatch values.
    while (subjectsRes.hasMoreElements()) {
      var subjectRes = subjectsRes.getNext();
      if (passwordMaker.defaultSubjectRes == subjectRes)
        passwordMaker.autoPopDefault = true;
      else {
        var urlToMatch = passwordMaker._getLiteral(subjectRes, passwordMaker.urlToMatchPredicateRes);
        if (urlToMatch != null && urlToMatch != "")
          passwordMaker.autoPopURLs[passwordMaker.autoPopURLs.length] = new Field(subjectRes, urlToMatch);
      }
    }
  },

  /**
   * Callback function called by Mozilla when context-menu appears
   */
  contextPopupShowing : function() {
    var target = gContextMenu.target;
    // target can be null when opening something like
    // chrome://passwdmaker/chrome/uris.xul directly in the browser.
    if (target) {
      //var type = target.type; // always lower-case
      document.getElementById("passwordmaker").hidden = 
        !(target.tagName == "INPUT" || target.tagName == "TEXTAREA");
      // Save a reference to the object being clicked
      passwordMaker.clickedElement = gContextMenu.target;
    }
  },

  /**
   * Callback function called by Mozilla when the context-menu
   * item has been clicked
   */
  onContextMenuClick : function() {
    if (passwordMaker.clickedElement) {
      // Is it a pw, username, or other field?
      if (passwordMaker.clickedElement.tagName == "INPUT" && passwordMaker.clickedElement.type.match(/text/i) && passwordMaker.clickedElement.name.match(/ID|un|name|user|usr|log|email|mail/i)) {
        // It's a username field        
        // Get matching accounts (if any)     
        var matchingSubjectResArray = passwordMaker._findMatches(passwordMaker._getURI(), passwordMaker.allURLs);
        if (matchingSubjectResArray.length == 0)
          matchingSubjectResArray.push(passwordMaker.defaultSubjectRes);
        passwordMaker._processRequest(matchingSubjectResArray, {usernames: new Array(passwordMaker.clickedElement), passwords: new Array()});        
      }
      else if(passwordMaker.clickedElement.tagName == "INPUT" && (passwordMaker.clickedElement.type.match(/pass/i) || (passwordMaker.clickedElement.type.match(/text/i) && passwordMaker.clickedElement.name.match(/pass|word|pw/i)))) {
        // It's a password field        
        // Get matching accounts (if any)     
        var matchingSubjectResArray = passwordMaker._findMatches(passwordMaker._getURI(), passwordMaker.allURLs);
        if (matchingSubjectResArray.length == 0)
          matchingSubjectResArray.push(passwordMaker.defaultSubjectRes);
        passwordMaker._processRequest(matchingSubjectResArray, {usernames: new Array(), passwords: new Array(passwordMaker.clickedElement)});      
      }
      else {
        // Other fields
      }     
      passwordMaker.clickedElement = null; // Remove reference to the saved element which was saved in contextPopupShowing()
    }
  },

  _processRequest : function(matchingSubjectResArray, unAndPw, populatationAction) {
    if (!populatationAction)
      populatationAction = "pop-all";
      
    // Prompt user to choose account (if necessary)           
    var matchingSubjectRes = matchingSubjectResArray.length > 1 ?
        passwordMaker._promptUserToChooseAccount(matchingSubjectResArray) : matchingSubjectResArray[0];
        
    if (unAndPw.usernames.length > 0) {     
      // Handle usernames      
      if (matchingSubjectRes) {
        passwordMaker._populateUsernames(unAndPw.usernames, matchingSubjectRes, populatationAction);
      }
    }    
    if (unAndPw.passwords.length > 0) {
      // Handle passwords        
      if (matchingSubjectRes)  {
        passwordMaker._populatePasswords(unAndPw.passwords, matchingSubjectRes, populatationAction);           
      }
    } 
  },

  _processShortcut : function(doc) {  
    // Check to see if the page has username/password fields
    var unAndPw = passwordMaker._getUsernameAndPasswordFields(doc);
    if (unAndPw.usernames.length == 0 && unAndPw.passwords.length == 0)
      return;
      
    if (passwordMaker.passwordShortcut == "clear-all") {
      // Clear the usernames
      for (var i=0; i<unAndPw.usernames.length; i++)
        unAndPw.usernames[i].value = "";
        
      // Clear the passwords
      for (var i=0; i<unAndPw.passwords.length; i++)
        unAndPw.passwords[i].value = "";
      return;
    }
    else if (passwordMaker.passwordShortcut == "empty-only") {
      // If there's nothing empty, just return because we don't
      // want to prompt the user to choose an account if there's
      // more than one match.
      var foundEmptyField = false;
      for (var i=0; !foundEmptyField && i<unAndPw.usernames.length; i++) {
        if (unAndPw.usernames[i].value == "")
          foundEmptyField = true;
      }
      for (var i=0; !foundEmptyField && i<unAndPw.passwords.length; i++) {
        if (unAndPw.passwords[i].value == "")
          foundEmptyField = true;
      }
      // There are no empty fields to populate, so don't bother continuing
      if (!foundEmptyField)
        return;        
    }
    var matchingSubjectResArray = passwordMaker._findMatches(doc.URL, passwordMaker.allURLs);
    if (matchingSubjectResArray.length == 0)
      matchingSubjectResArray.push(passwordMaker.defaultSubjectRes);
    passwordMaker._processRequest(matchingSubjectResArray, unAndPw, passwordMaker.passwordShortcut);
  },  

  /**
   * Callback function called by Mozilla when a page loads
   */
  pageLoad : function(evt) {
    // doc is document that triggered onload event
    var doc = evt.originalTarget;
    var matchingSubjectResArray = passwordMaker._findMatches(doc.URL, passwordMaker.autoPopURLs);
    if (matchingSubjectResArray.length == 0 && passwordMaker.autoPopDefault)
      matchingSubjectResArray.push(passwordMaker.defaultSubjectRes);
    if (matchingSubjectResArray.length > 0) {
      // Check to see if the page has username/password fields
      var unAndPw = passwordMaker._getUsernameAndPasswordFields(doc);
      if (unAndPw.usernames.length > 0 || unAndPw.passwords.length > 0)
        passwordMaker._processRequest(matchingSubjectResArray, unAndPw);
    }   
  },  

  /**
   * Called on alt-` keyboard click
   */
  populateFields : function() {
    // off, pop-all, empty-only, clear-all
    if (passwordMaker.passwordShortcut == "off")
      return;

    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var recentWindow = wm.getMostRecentWindow("navigator:browser");
    if (recentWindow) {
      passwordMaker._processShortcut(recentWindow.content.document);
    }
  },
    
  /**
   * Given a subject and predicate, return the literal
   * of the associated target (we're assuming there's
   * only a single target). If the target doesn't exist
   * or isn't a literal, return null.
   */
  _getLiteral : function(subjectRes, predicateRes) {
    var targetRes = passwordMaker.passwordMakerHelper.datasource.GetTarget(subjectRes, predicateRes, true);
    return targetRes instanceof Components.interfaces.nsIRDFLiteral ? targetRes.Value : null;
  },

  /**
   * Generate the site-specific password and return it. If there are any
   * problems decrypting the master password, throw an exception.
   */
  _generateSiteSpecificPassword : function(selectedSubjectRes) {

    var decryptedMasterPassword = passwordMaker.passwordMakerHelper.getDecryptedMasterPassword();
    if (decryptedMasterPassword == null)
      return null; // user might simply have hit the cancel button when prompted.

    var name = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.namePredicateRes);
    var description = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.descriptionPredicateRes);
    var username = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.usernameTBPredicateRes);

    var hashAlgorithm = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.hashAlgorithmLBPredicateRes),
      whereLeet = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.whereLeetLBPredicateRes),
      leetLevel = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.leetLevelLBPredicateRes),
      passwordLength = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.passwordLengthPredicateRes),
      protocol = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.protocolCBPredicateRes),
      subdomain = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.subdomainCBPredicateRes),
      domain = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.domainCBPredicateRes),
      path = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.pathCBPredicateRes),
      charset = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.charsetPredicateRes),
      prefix = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.prefixPredicateRes),
      suffix = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.suffixPredicateRes);

    var uri = "", usernameTB = "", counter = "";
    if (selectedSubjectRes == passwordMaker.defaultSubjectRes) {
      // Determine which part(s) of the URI to use in the password generation algorithm
      uri = passwordMaker.calculateURI(protocol == "true",
                                        subdomain == "true",
                                        domain == "true",
                                        path == "true", //@TODO: change this to port when supported in the GUI
                                        path == "true");
    }
    else {
      uri = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.urlToUsePredicateRes);
      usernameTB = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.usernameTBPredicateRes);
      counter = passwordMaker._getLiteral(selectedSubjectRes, passwordMaker.counterPredicateRes);
    }

    // Generate the site-specific password
    var ret = passwordMaker.passwordMakerHelper.generatepassword(hashAlgorithm, decryptedMasterPassword,
                          uri + usernameTB + counter, whereLeet, leetLevel, passwordLength, charset, prefix, suffix);

    //dump(ret + "\n");
    // Just to be safe, don't wait for the garbage collector to reclaim the clear-text master password in memory.
    // Even though the variable is on the calling stack (not the heap) and probably doesn't get garbage-collected
    // (I just don't know enough about Mozilla's JavaScript interpreter) -- just tossed -- we set the value to null.
    // This also ensures the stack frame contents -- which probably still exist after the function returns (at least
    // until function calls of the same depth occur) -- can't be inspected to find the decrypted password.
    decryptedMasterPassword = null;
    return {password:ret, subjectRes:selectedSubjectRes}; 
  },
    
  _findMatches : function(url, urlsArray) {    
    var matches = new Array();
    for (var i=0; url && i<urlsArray.length; i++) {
      if (url.indexOf(urlsArray[i].urlToMatch) > -1)
        matches.push(urlsArray[i].subjectRes);
    }
    return matches;
  },
  
  _getUsernameAndPasswordFields : function(TargetContent) {
    // Inspired by BugMeNot Extension by Roachfiend
    var ret = {usernames: new Array(), passwords: new Array()};
    
    for(var xx = 0; xx < TargetContent.forms.length; ++xx) {
      var TargetForm = TargetContent.forms[xx];
      var FoundSubmitButton = false;
      for(var xxx = 0; xxx < TargetForm.elements.length; ++xxx) {
        if(TargetForm.elements[xxx].tagName == "INPUT" && TargetForm.elements[xxx].type.match(/text/i) && TargetForm.elements[xxx].name.match(/ID|un|name|user|usr|log|email|mail/i))
          ret.usernames[ret.usernames.length] = TargetForm.elements[xxx];
        else if(TargetForm.elements[xxx].tagName == "INPUT" && (TargetForm.elements[xxx].type.match(/pass/i) || (TargetForm.elements[xxx].type.match(/text/i) && TargetForm.elements[xxx].name.match(/pass|word|pw/i))))
          ret.passwords[ret.passwords.length] = TargetForm.elements[xxx];
        //if(TargetForm.elements[xxx].tagName == "INPUT" && TargetForm.elements[xxx].type.match(/submit|button|image/i) && (TargetForm.elements[xxx].src.match(/log|sub|sign/i) || TargetForm.elements[xxx].value.match(/log|sub|sign/i) || TargetForm.elements[xxx].name.match(/log|sub|sign/i)))
          //FoundSubmitButton = true;
      }
    }

    if (TargetContent.frames) {
      // TODO: test if this works with frames
      for(var x = 0; x < TargetContent.frames.length; ++x) {
        var TargetFrame = TargetContent.frames[x];
        for(var xx = 0; xx < TargetFrame.document.forms.length; ++xx) {
          var TargetForm = TargetFrame.document.forms[xx];
          for(var xxx = 0; xxx < TargetForm.elements.length; ++xxx) {
            if(TargetForm.elements[xxx].tagName == "INPUT" && TargetForm.elements[xxx].type.match(/text/i) && TargetForm.elements[xxx].name.match(/ID|un|name|user|usr|log|email|mail/i))
              ret.usernames[ret.usernames.length] = TargetForm.elements[xxx];
            if(TargetForm.elements[xxx].tagName == "INPUT" && (TargetForm.elements[xxx].type.match(/pass/i) || (TargetForm.elements[xxx].type.match(/text/i) && TargetForm.elements[xxx].name.match(/pass|word|pw/i))))
              ret.passwords[ret.passwords.length] = TargetForm.elements[xxx];
            //if(TargetForm.elements[xxx].tagName == "INPUT" && TargetForm.elements[xxx].type.match(/submit|button|image/i) && (TargetForm.elements[xxx].src.match(/log|sub|sign/i) || TargetForm.elements[xxx].value.match(/log|sub|sign/i) || TargetForm.elements[xxx].name.match(/log|sub|sign/i)))
              //FoundSubmitButton = true;
          }
        }
      }
    }
    return ret;
  },
  
  _populateUsernames : function(unFields, subjectRes, action) {      
    var username = passwordMaker._getLiteral(subjectRes, passwordMaker.usernameTBPredicateRes);
    if (username == null)
      return;
    for (var i=0; i<unFields.length; i++) {
      if (action == "pop-all" || (action == "empty-only" && unFields[i].value == ""))
        unFields[i].value = username;
    }
  },


  /**
   * Populate the password fields in _doc_
   * with the generated password.
   */
  _populatePasswords : function(pwFields, subjectRes, action) {
    var matchingFact = null;
    for (var i=0; i<pwFields.length; i++) {
      if (action == "pop-all" || (action == "empty-only" && pwFields[i].value == "")) {
        // generate the password for this page if it hasn't already been generated
        if (matchingFact == null) {
          matchingFact = passwordMaker._generateSiteSpecificPassword(subjectRes);
          if (matchingFact == null) // user clicked cancel
            return;
        }
        pwFields[i].value = matchingFact.password;
      }
    }

    /*if (matchingFact) {
      // Look for other fields to pop 
      matchingFact.subjectRes = matchingFact.subjectRes.QueryInterface(Components.interfaces.nsIRDFResource);
      //dump("subjectRes=" + matchingFact.subjectRes.Value + "\n");
      passwordMaker._populateUsername(matchingFact.subjectRes);
      var subjectRes = passwordMaker.passwordMakerHelper.rdfService.GetResource(matchingFact.subjectRes.Value + "/fields");
      if (passwordMaker.passwordMakerHelper.rdfContainerUtils.IsEmpty(passwordMaker.passwordMakerHelper.datasource, subjectRes))
        return;
      var fieldsContainer = passwordMaker.passwordMakerHelper.rdfContainerUtils.MakeSeq(passwordMaker.passwordMakerHelper.datasource, subjectRes);
      var autoFillFields = {};
      var fieldsContainterIter = fieldsContainer.GetElements();
      while (fieldsContainterIter.hasMoreElements()) {
        var fieldSubj = fieldsContainterIter.getNext();
        if (fieldSubj instanceof Components.interfaces.nsIRDFResource) {
          var name = passwordMaker._getLiteral(fieldSubj, passwordMaker.fieldNamePredRes);
          var value = passwordMaker._getLiteral(fieldSubj, passwordMaker.fieldValuePredRes);
          autoFillFields[name] = value;
          //dump("autoFillFields[" + name + "] = " + value + "\n");
        }
      }
      for (i in autoFillFields) {
        dump("i=" + i + "\n");
        for (var j=0;j<inputElements.length; j++) {
          //dump(inputElements[j].name + " " + inputElements[j].type + "\n");
          if (inputElements[j].name == i) {
            inputElements[j].value = autoFillFields[i];
            dump("found it\n");
            break;
          }
        }
      }
    }*/
  },
    
  _promptUserToChooseAccount : function(subjectRes) {
    var selectedSubjectRes;
    //dump("subjectRes length is " + subjectRes.length + "\n");
    if (subjectRes.length == 1)
      selectedSubjectRes = subjectRes[0];
    else {
      // There are multiple accounts for this URL. Prompt the user for which one to use
      var params = {inn:{accounts : subjectRes, passwordMaker : passwordMaker}, out:null};
      window.openDialog("chrome://passwdmaker/chrome/chooseaccount.xul", "",
          "chrome, dialog, modal, resizable=yes", params).focus();
      if (params.out) {
        // User clicked OK
        selectedSubjectRes = params.out.selection;
      }
      else {
        // User clicked cancel
        return null;
      }
    }
    return selectedSubjectRes;
  },

  /**
   * Open the main PasswordMaker dialog
   */
  open : function() {
    // If there's a passwordmaker dialog window already open,
    // just focus it and return.
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var e = wm.getEnumerator("passwordmaker");
    if (e.hasMoreElements()) {
      var passwordmakerInstance = e.getNext(); 
      passwordmakerInstance.focus();
      return;
    }
    // Now open passwordmaker dialog.
    // We don't really need a 10 msec delay here, but this lets me
    // easily re-use all the code in the _open() method.
    setTimeout(this._open, 10);
  },

  /**
   * setTimeout() callback function.
   */
  _open : function() {
    // Basic options dialog is resizable because we open it with
    // a specific size in pixels (how to specify in ems?) The entire
    // dialog contents use ems, but if we open in pixels it could look
    // weird on some resolutions/font sizes, so we give the user the
    // option to resize it. Opening the dialog in ems would get around
    // this problem and we could make resizable false.
    var xulfilename = passwordMaker.advancedOptionsDialog == "true" ? "chrome://passwdmaker/content/advanced-options.xul" : "chrome://passwdmaker/content/basic-options.xul";
    passwordMaker.dlg = window.openDialog(xulfilename, "", "dialog,chrome,resizable=yes", {passwordMakerHelper : passwordMaker.passwordMakerHelper});
    passwordMaker.dlg.focus();
  },

  /**
   * Switch from basic options to advanced, or vice-versa.
   * Update the preferences.
   */
  switchOptionsDialog : function() {
    this.advancedOptionsDialog = this.advancedOptionsDialog == "true" ? "false" : "true";
    passwordMaker.passwordMakerHelper.saveGlobalSetting("advancedOptionsDialog", this.advancedOptionsDialog);

    // Inspired by delayedOpenWindow() in browser.js.
    setTimeout(this._open, 10);
  },

  /**
   * Called by calculateURI()
   */
  _parseURI : function(aURI) {
    var temp = aURI.match("([^://]+://)([^/:]*):?([0-9]*)(.*)");  // \d isn't working in place of [0-9], why not?
    if (!temp)
      throw this;
    return { protocol: temp[1],
             domains : temp[2].split("."), // temp[2] is the url without protocol, port, path, query parms, anchor
             port    : temp[3],
             path    : temp[4]};
  },

  _getURI : function() {
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var recentWindow = wm.getMostRecentWindow("navigator:browser");
    if (recentWindow)
      return new String(recentWindow.content.document.location);
    else
      return "";
  },

  calculateURI : function(includeProtocol, includeSubdomain, includeDomain, includePort, includePath) {

    var aURI = passwordMaker._getURI();
    if (includeProtocol && includeSubdomain && includeDomain && includePath && includePath)
      return aURI;

    if (!includeProtocol && !includeSubdomain && !includeDomain && !includePath && !includePath)
      return "";
    
    var uriComponents;
    try {
      uriComponents = this._parseURI(aURI);
    }
    catch (e) {
      return aURI; // aURI isn't parsable; e.g., about:config, javascript:, about:blank
    }

    var ret = includeProtocol ? uriComponents.protocol : ""; // set the protocol or empty string

    // Check if, for example, domains['co.uk'] == true
    var TLDrequiresSLD = eval("passwordMaker.domains['" + uriComponents.domains[uriComponents.domains.length-2] + "." +
                            uriComponents.domains[uriComponents.domains.length-1] + "']");


    // TODO: logic for third-level domains !

    if (includeSubdomain) {
      // The subdomains are all domains except the final two, unless
      // the TLD is a ccTLD which requires a SLD. In the latter case,
      // the subdomains are all domains except the final three.
      var len = TLDrequiresSLD ? uriComponents.domains.length-3 : uriComponents.domains.length-2;
      for (var i=0; i<len; i++) {
        ret += uriComponents.domains[i];
        // Add a dot if this isn't the final subdomain
        if (i+1 < len)
          ret += ".";
      }			
    }

    if (includeDomain) {
      if (ret != "" && ret[ret.length-1] != "." && ret[ret.length-1] != "/")
        ret += ".";

      if (uriComponents.domains.length == 1) {
        // e.g., localhost (no .com or other domains)
        ret += uriComponents.domains[0];
      }
      else {
        // The domain for a ccTLD which requires SLD is really SLD+ccTLD;
        // e.g., ac.uk instead of just .uk
        if (TLDrequiresSLD)
          ret += uriComponents.domains[uriComponents.domains.length-3] + ".";
        ret += uriComponents.domains[uriComponents.domains.length-2] + "." + uriComponents.domains[uriComponents.domains.length-1];
      }
    }

    if (includePort)
      ret += ":" + uriComponents.port;

    if (includePath)
      ret += uriComponents.path;

    return ret;
  }
};